import ReviewPlanOrder from "@/components/rendering/reviewPlanOrder";
import { getESimList } from "@/utils/api/auth";
import { getPlanDetailsCountryRegion } from "@/utils/api/countryRegion";
import { getCookie, getCookieFromRequest } from "@/utils/useHooks/useCookies";
import { getItemFromSession } from "@/utils/useHooks/useStorage";
import Head from "next/head";
import { useRouter } from "next/router";
import { parseCookies } from "nookies";
import { useEffect, useState } from "react";

export default function ReviewOrderPage({
  mcc,
  plan_id,
  region_id,
  isUserLogedIn,
  token,
  topupId,
}: any) {
  const [reviewOrderData, setReviewOrderData] = useState(null);
  let reviewOrder = getItemFromSession("reviewOrder");
  const [eSimList, setESimList] = useState<any>(null);
  const [loaging, setLoaging] = useState<any>(false);

  const handleOnFetchPlanDetails = async () => {
    let payLoad = {
      mcc: mcc,
      plan_id: plan_id,
      region_id: region_id,
    };
    const { isError, response } = await getPlanDetailsCountryRegion(payLoad);
    setReviewOrderData(response);
  };

  useEffect(() => {
    if (reviewOrder?.planId === plan_id) {
      setReviewOrderData(reviewOrder);
    } else {
      handleOnFetchPlanDetails();
    }
  }, []);

  async function fetchESimList() {
    setLoaging(true);
    try {
      let waotoken = getCookie("waotoken");
      const { isError, response } = await getESimList({ waotoken });

      if (topupId) {
        let topUpEsimData = response?.data?.filter(
          (item: any) => item?.iccid === topupId
        );
        setESimList(topUpEsimData);
      } else {
        setESimList(response?.data);
      }
      setLoaging(false);
    } catch (error) {
      console.error(error);
      setLoaging(false);
    }
  }

  useEffect(() => {
    fetchESimList();
  }, []);

  return (
    <>
      <Head>
        <title>WaoSim | review-order</title>
        <meta name="description" content="Generated by create next app" />
        <meta name="viewport" content="width=device-width, initial-scale=1" />
        <link rel="icon" href="/faviconIcon.svg" />
      </Head>
      <main>
        <ReviewPlanOrder
          reviewOrderData={reviewOrderData}
          plan_id={plan_id}
          eSimList={eSimList}
          setReviewOrderData={setReviewOrderData}
          loaging={loaging}
          topupId={topupId}
        />
      </main>
    </>
  );
}

export async function getServerSideProps(context: any) {
  const { req, res, query } = context;
  const { mcc, plan_id, region_id, topupId } = query;

  const cookies = parseCookies({ req });

  if (!cookies?.waotoken) {
    return {
      redirect: {
        destination: "/auth/login",
        permanent: false,
      },
    };
  }

  return {
    props: {
      mcc: mcc ?? "",
      plan_id: plan_id ?? "",
      region_id: region_id ?? "",
      token: cookies?.waotoken ?? "",
      topupId: topupId ?? null,
    },
  };
}
